Next Previous Up Contents
Next: Examples
Up: arrayjoin: Adds table-per-row data as array-valued columns
Previous: arrayjoin: Adds table-per-row data as array-valued columns

### B.1.1 Usage

The usage of `arrayjoin` is

       stilts <stilts-flags> arrayjoin ifmt=<in-format> istream=true|false
                                       icmd=<cmds> ocmd=<cmds>
                                       omode=out|meta|stats|count|checksum|cgi|discard|topcat|samp|plastic|tosql|gui
                                       out=<out-table> ofmt=<out-format>
                                       atable=<loc-expr> afmt=<in-format>
                                       astream=true|false acmd=<cmds>
                                       keepall=true|false aparams=<name-list>
                                       cache=true|false fixcols=none|dups|all
                                       suffixarray=<label>
                                       [in=]<table>

If you don't have the `stilts` script installed, write "`java -jar stilts.jar`" instead of "`stilts`" - see Section 3. The available `<stilts-flags>` are listed in Section 2.1. For programmatic invocation, the Task class for this command is `uk.ac.starlink.ttools.task.ArrayJoin`.

Parameter values are assigned on the command line as explained in Section 2.3. They are as follows:

`acmd = <cmds>` (ProcessingStep[])
  Specifies processing to be performed on array tables as specified by parameter `atable`, before any other processing has taken place. The value of this parameter is one or more of the filter commands described in Section 6.1. If more than one is given, they must be separated by semicolon characters (";"). This parameter can be repeated multiple times on the same command line to build up a list of processing steps. The sequence of commands given in this way defines the processing pipeline which is performed on the table.

  Commands may alternatively be supplied in an external file, by using the indirection character '`@`'. Thus a value of "`@filename`" causes the file `filename` to be read for a list of filter commands to execute. The commands in the file may be separated by newline characters and/or semicolons, and lines which are blank or which start with a '`#`' character are ignored. A backslash character '`\`' at the end of a line joins it with the following line.

`afmt = <in-format>` (String)
  Specifies the format of array tables as specified by parameter `atable`. The known formats are listed in Section 5.1.1. This flag can be used if you know what format your table is in. If it has the special value `(auto)` (the default), then an attempt will be made to detect the format of the table automatically. This cannot always be done correctly however, in which case the program will exit with an error explaining which formats were attempted. This parameter is ignored for scheme-specified tables.

  [Default: `(auto)`]

`aparams = <name-list>` (String)
  Lists the table parameters (per-table metadata) that will be read from loaded tables and turned into scalar-valued columns in the output. By default parameters are discarded, but you can include them in the output by naming them using this parameter.

  Parameters are supplied as a space- or comma-separated list. Matching against table names is case-insensitive, and the asterisk character "`*`" may be used as a wildcard to match any sequence of characters. The list is interpreted relative to the first external table which is loaded. Supplying the value "`*`" therefore will include a column for each parameter in the first loaded table.

`astream = true|false` (Boolean)
  If set true, array tables specified by the `atable` parameter will be read as a stream. It is necessary to give the `afmt` parameter in this case. Depending on the required operations and processing mode, this may cause the read to fail (sometimes it is necessary to read the table more than once). It is not normally necessary to set this flag; in most cases the data will be streamed automatically if that is the best thing to do. However it can sometimes result in less resource usage when processing large files in certain formats (such as VOTable). This parameter is ignored for scheme-specified tables.

  [Default: `false`]

`atable = <loc-expr>` (String)
  Gives the location of the table whose rows will be turned into an array-valued column. This will generally be an expression giving a URL or filename that is different for each row of the input table. If table loading fails for the given location, for instance becase the file is not found or an HTTP 404 response is received, the array cells in the corresponding row will be blank.

  The first non-blank table loaded defines the array columns to be added. If subsequent tables have a different structure (do not contain similar columns in a similar sequence) an error may result. If the external array tables are not all homogenous in this way, the `acmd` parameter can be used to filter them so that they are.

`cache = true|false` (Boolean)
  Determines whether the array data will be cached the first time an array table is read (true) or re-read from the array table every time the row is accessed (false). Since the row construction may be an expensive step, especially if the tables are downloaded, it usually makes sense to set this true (the default). When true it also enables the metadata to be adjusted to report constant array length where applicable, which cannot be done before all the rows have been scanned, and which may enable more efficient file output. However, if you want to stream the data you can set it false.

  [Default: `true`]

`fixcols = none|dups|all` (Fixer)
  Determines how input columns are renamed before use in the output table. The choices are:
  - `none`: columns are not renamed
  - `dups`: columns which would otherwise have duplicate names in the output will be renamed to indicate which table they came from
  - `all`: all columns will be renamed to indicate which table they came from
  If columns are renamed, the new ones are determined by `suffix*` parameters.

  [Default: `dups`]

`icmd = <cmds>` (ProcessingStep[])
  Specifies processing to be performed on the input table as specified by parameter `in`, before any other processing has taken place. The value of this parameter is one or more of the filter commands described in Section 6.1. If more than one is given, they must be separated by semicolon characters (";"). This parameter can be repeated multiple times on the same command line to build up a list of processing steps. The sequence of commands given in this way defines the processing pipeline which is performed on the table.

  Commands may alternatively be supplied in an external file, by using the indirection character '`@`'. Thus a value of "`@filename`" causes the file `filename` to be read for a list of filter commands to execute. The commands in the file may be separated by newline characters and/or semicolons, and lines which are blank or which start with a '`#`' character are ignored. A backslash character '`\`' at the end of a line joins it with the following line.

`ifmt = <in-format>` (String)
  Specifies the format of the input table as specified by parameter `in`. The known formats are listed in Section 5.1.1. This flag can be used if you know what format your table is in. If it has the special value `(auto)` (the default), then an attempt will be made to detect the format of the table automatically. This cannot always be done correctly however, in which case the program will exit with an error explaining which formats were attempted. This parameter is ignored for scheme-specified tables.

  [Default: `(auto)`]

`in = <table>` (StarTable)
  The location of the input table. This may take one of the following forms:
  - A filename.
  - A URL.
  - The special value "`-`", meaning standard input. In this case the input format must be given explicitly using the `ifmt` parameter. Note that not all formats can be streamed in this way.
  - A scheme specification of the form `:<scheme-name>:<scheme-args>`.
  - A system command line with either a "`<`" character at the start, or a "`|`" character at the end ("`<syscmd`" or "`syscmd|`"). This executes the given pipeline and reads from its standard output. This will probably only work on unix-like systems.
  In any case, compressed data in one of the supported compression formats (gzip, Unix compress or bzip2) will be decompressed transparently.
`istream = true|false` (Boolean)
  If set true, the input table specified by the `in` parameter will be read as a stream. It is necessary to give the `ifmt` parameter in this case. Depending on the required operations and processing mode, this may cause the read to fail (sometimes it is necessary to read the table more than once). It is not normally necessary to set this flag; in most cases the data will be streamed automatically if that is the best thing to do. However it can sometimes result in less resource usage when processing large files in certain formats (such as VOTable). This parameter is ignored for scheme-specified tables.

  [Default: `false`]

`keepall = true|false` (Boolean)
  This parameter determines what happens when the `atable` parameter does not name a table that can be loaded. If this parameter is false, the input table row is output with blank values in the columns supplied by the array tables, so that the output table has the same number of rows as the input table. If it is true, only rows with successfully loaded tables are included in the output.

  [Default: `true`]

`ocmd = <cmds>` (ProcessingStep[])
  Specifies processing to be performed on the output table, after all other processing has taken place. The value of this parameter is one or more of the filter commands described in Section 6.1. If more than one is given, they must be separated by semicolon characters (";"). This parameter can be repeated multiple times on the same command line to build up a list of processing steps. The sequence of commands given in this way defines the processing pipeline which is performed on the table.

  Commands may alternatively be supplied in an external file, by using the indirection character '`@`'. Thus a value of "`@filename`" causes the file `filename` to be read for a list of filter commands to execute. The commands in the file may be separated by newline characters and/or semicolons, and lines which are blank or which start with a '`#`' character are ignored. A backslash character '`\`' at the end of a line joins it with the following line.

`ofmt = <out-format>` (String)
  Specifies the format in which the output table will be written (one of the ones in Section 5.1.2 - matching is case-insensitive and you can use just the first few letters). If it has the special value "`(auto)`" (the default), then the output filename will be examined to try to guess what sort of file is required usually by looking at the extension. If it's not obvious from the filename what output format is intended, an error will result.

  This parameter must only be given if `omode` has its default value of "`out`".

  [Default: `(auto)`]

`omode = out|meta|stats|count|checksum|cgi|discard|topcat|samp|plastic|tosql|gui` (ProcessingMode)
  The mode in which the result table will be output. The default mode is `out`, which means that the result will be written as a new table to disk or elsewhere, as determined by the `out` and `ofmt` parameters. However, there are other possibilities, which correspond to uses to which a table can be put other than outputting it, such as displaying metadata, calculating statistics, or populating a table in an SQL database. For some values of this parameter, additional parameters (`<mode-args>`) are required to determine the exact behaviour.

  Possible values are

  - `out`
  - `meta`
  - `stats`
  - `count`
  - `checksum`
  - `cgi`
  - `discard`
  - `topcat`
  - `samp`
  - `plastic`
  - `tosql`
  - `gui`
  Use the `help=omode` flag or see Section 6.4 for more information.

  [Default: `out`]

`out = <out-table>` (TableConsumer)
  The location of the output table. This is usually a filename to write to. If it is equal to the special value "-" (the default) the output table will be written to standard output.

  This parameter must only be given if `omode` has its default value of "`out`".

  [Default: `-`]

`suffixarray = <label>` (String)
  If the `fixcols` parameter is set so that input columns are renamed for insertion into the output table, this parameter determines how the renaming is done. It gives a suffix which is appended to all renamed columns from the array tables.

  [Default: `_a`]

Next Previous Up Contents
Next: Examples
Up: arrayjoin: Adds table-per-row data as array-valued columns
Previous: arrayjoin: Adds table-per-row data as array-valued columns

STILTS - Starlink Tables Infrastructure Library Tool Set
Starlink User Note256
STILTS web page: http://www.starlink.ac.uk/stilts/
Author email: m.b.taylor@bristol.ac.uk
Mailing list: topcat-user@jiscmail.ac.uk